%define device_mapper_version 1.02.17-2

Summary: Cluster extensions for userland logical volume management tools 
Name: lvm2-cluster
Version: 2.02.21
Release: 7.el4.XOS.1
License: GPL
Group: System Environment/Base
URL: http://sources.redhat.com/lvm2
Source0: LVM2.%{version}.tgz
Patch0: lvm2-rhel4u5.patch
Patch1: cluster-locking-built-in.patch
Patch2: lvm2-2_02_24-fix-nolocking.patch
Patch3: lvm2-2_02_24-fix-lvm1-import.patch
Patch4: lvm2-2_02_24-fix-initscripts.patch
Patch5: lvm2-2_02_25-fix-tagged-mirrors.patch
Patch6: lvm2-clvmd-timeout.patch
Patch7: lvm2-2_02_25-fix-race.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post): chkconfig
Requires(preun): chkconfig
Requires(post): device-mapper >= %{device_mapper_version}
Requires(preun): device-mapper >= %{device_mapper_version}
Requires(post): lvm2 >= %{version}
Requires(preun): lvm2 >= %{version}
Requires: lvm2 >= %{version}
Requires: mkinitrd >= 4.2.1.3-1
BuildRequires: device-mapper >= %{device_mapper_version}
BuildRequires: libselinux-devel
BuildRequires: libsepol-devel
BuildRequires: dlm-devel
BuildRequires: gulm-devel
BuildRequires: ccs-devel
BuildRequires: libtermcap-devel
BuildRequires: ncurses-devel
BuildRequires: readline-devel
BuildRequires: cman-devel
ExclusiveArch: i386 ia64 x86_64 ppc64

%description
Extensions to LVM2 to support clusters.

%prep
%setup -q -n LVM2.%{version}
%patch -p1 -b .rhel4u5
%patch1 -p1 -b .locking
%patch2 -p1 -b .nolocking
%patch3 -p1 -b .lvm1
%patch4 -p1 -b .init
%patch5 -p1 -b .tags
%patch6 -p1 -b .timeout
%patch7 -p1 -b .race

%build
%configure --with-clvmd=all --with-cluster=shared --with-user= --with-group= --enable-dmeventd --enable-cmdlib
make DESTDIR=$RPM_BUILD_ROOT

%install
rm -rf $RPM_BUILD_ROOT
make install_cluster DESTDIR=$RPM_BUILD_ROOT

mkdir -p -m755 $RPM_BUILD_ROOT/etc/rc.d/init.d
install scripts/clvmd_init_rhel4 $RPM_BUILD_ROOT/etc/rc.d/init.d/clvmd
install -m 0755 scripts/lvmconf.sh $RPM_BUILD_ROOT/usr/sbin/lvmconf

# do not enable init script by default
perl -pi -e 's/# chkconfig: \d+ /# chkconfig: - /' \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/*

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add clvmd
/usr/sbin/lvmconf --lockinglibdir %{_libdir}

%preun
if [ "$1" = 0 ]; then
	/sbin/chkconfig --del clvmd
	/usr/sbin/lvmconf --disable-cluster
fi

%files
%defattr(-,root,root,-)
%{_sbindir}/clvmd
%{_sbindir}/lvmconf
%{_libdir}/liblvm2clusterlock.so
%{_libdir}/liblvm2clusterlock.so.2.02
%{_mandir}/man8/clvmd.8.gz
/etc/rc.d/init.d/clvmd

%changelog
* Tue May 15 2007 X/OS Linux Team <xoslinux@xos.nl> 2.02.21-7.el4.XOS.1
- Build for X/OS Linux 4.
- X/OS Linux source rpm based on lvm2-cluster-2.02.21-7.el4.src.rpm
  (md5sum of original source rpm: fb0e4cf15af06082a3f548fc37e3efea).
- Do not enable init script by default.

* Tue Apr 24 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-7
- Fix thread race in clvmd.
- Resolves: rhbz#236432

* Tue Apr 17 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-6
- Increase timeout for clvmd
- Resolves: rhbz#235092

* Mon Mar 26 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-5
- Rebuild - updated lvm2 base package.
- Resolves: rhbz#229471

* Mon Mar 19 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-4
- Fix processing of exit status in init scripts.
- Flag nolocking as clustered so clvmd startup sees clustered LVs.
- Resolves: rhbz#231979 rhbz#232707

* Fri Feb 02 2007 Milan Broz <mbroz@redhat.com> - 2.02.21-3
- Build against latest device-mapper package

* Fri Feb 02 2007 Alasdair Kergon <agk@redhat.com> - 2.02.21-2
- Add ppc64.

* Tue Jan 30 2007 Alasdair Kergon <agk@redhat.com> - 2.02.21-1
- Updated lvm2 core.

* Fri Jan 26 2007 Alasdair Kergon <agk@redhat.com> - 2.02.20-1
- Updated lvm2 core.
- Fix internal cache flushing in clvmd -R.

* Wed Jan 17 2007 Alasdair Kergon <agk@redhat.com> - 2.02.19-1
- Updated lvm2 core.

* Tue Jan 16 2007 Alasdair Kergon <agk@redhat.com> - 2.02.18-2
- Update spec file: BuildRequires, BuildRoot & Description typo.
- No longer enable by default on installation.
- The default is now locking_type 3 (lvm2 built-in).

* Fri Jan 12 2007 Alasdair Kergon <agk@redhat.com> - 2.02.18-1
- Updated lvm2 core.

* Thu Dec 14 2006 Alasdair Kergon <agk@redhat.com> - 2.02.17-1
- Add manpage entry for clvmd -T
- Fix hang in clvmd if a pre-command failed.

* Fri Dec 01 2006 Alasdair Kergon <agk@redhat.com> - 2.02.16-1
- Adjust some alignments for ia64. 
- Fix VG clustered read locks to use PR not CR. 
- Add startup timeout to clvmd startup script.

* Tue Nov 21 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-3
- Fix clvmd init script line truncation.

* Tue Nov 21 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-2
- Fix lvm.conf segfault.

* Mon Nov 20 2006 Alasdair Kergon <agk@redhat.com> - 2.02.15-1
- Updated lvm2 core.

* Fri Nov 10 2006 Alasdair Kergon <agk@redhat.com> - 2.02.14-1
- Fix clustered VG detection and default runlevels in clvmd_init_rhel4.
- Updated lvm2 core.

* Tue Oct 31 2006 Alasdair Kergon <agk@redhat.com> - 2.02.13-1
- Use dist variable for package release suffix.
- Added cman-devel dependency.
- Updated lvm2 core.

* Tue Sep 19 2006 Alasdair Kergon <agk@redhat.com> - 2.02.10
- New upstream with fixes.

* Mon Jul 24 2006 Chris Feist <cfeist@redhat.com> - 2.02.06-7.0
- Rebuilt with no_optimized_deactive patch.

* Mon Jul 17 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-6.0
- Rebuild with fix to last patch.

* Tue Jul 11 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-5.0
- Rebuild after recent lvm2 patches.

* Tue Jul 04 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-4.0
- Avoid clvm 'unaligned access' error on some archs. (194626, lost)
- Rebuild after recent lvm2 patches.

* Wed May 24 2006 Alasdair Kergon <agk@redhat.com> - 2.02.06-1.0
- Update to 2.02.06.
- BuildRequires libsepol-devel.
- Tidy spec file. [192100]

* Wed Mar 8 2006 Alasdair Kergon <agk@redhat.com> - 2.02.02-2.0
- Add missing chkconfig prereq.

* Fri Feb 10 2006 Alasdair Kergon <agk@redhat.com> - 2.02.02-1.0
- New upstream release.

* Thu Jan 12 2006 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.2
- Rebuild against latest libdevmapper.

* Wed Jan 04 2006 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.1
- Rebuild against latest libdevmapper.

* Mon Dec 05 2005 Alasdair Kergon <agk@redhat.com> - 2.02.01-1.0
- Update to latest upstream release.

* Tue Aug 16 2005 Alasdair Kergon <agk@redhat.com> - 2.01.14-1.0
- Incorporate additional upstream fixes since June.

* Tue Aug 16 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-6.0
- Add mkinitrd dependency to ensure it gets upgraded first. [165255]

* Tue Jun 14 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-5.0
- Couple of fixes to clvmd file descriptor closing.
- Fix potential spin loop in clvmd.

* Fri Jun 10 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-4.0
- Automatically enable clustering in lvm.conf on installation.

* Tue Jun 07 2005 Chris Feist <cfeist@redhat.com> - 2.01.09-3.1
- Rebuild against libgulm.so.1.0.0 (instead of libgulm.so.1.0).

* Tue May 17 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-3.0
- Fix clvmd init script.

* Thu Apr 21 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-2.1
- BuildRequires: dlm-devel, gulm-devel, ccs-devel

* Wed Apr 13 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-2.0
- Improve co-operation between clvmd and gulm over node state changes. [146056]

* Mon Apr 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-1.1
- Switch from 'ExcludeArch: s390 s390x ppc' to 
  'ExclusiveArch: i386 ia64 x86_64' to match dlm dependency.

* Mon Apr 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.09-1.0
- clvmd: Don't allow user operations to start until lvm thread is fully up.
- clvmd-gulm: Set KEEPALIVE on sockets.

* Tue Mar 22 2005 Alasdair Kergon <agk@redhat.com> - 2.01.08-1.0
- Improve detection of external changes affecting internal cache.

* Thu Mar 10 2005 Alasdair Kergon <agk@redhat.com> - 2.01.07-2.0
- clvmd lvm_thread_lock fix.

* Tue Mar 08 2005 Alasdair Kergon <agk@redhat.com> - 2.01.07-1.0
- clvmd FDs close-on-exec
- unlock gulm VG & orphan locks at startup in case they are stale
- unlock gulm VG & orphan locks if client dies.

* Fri Mar 04 2005 Alasdair Kergon <agk@redhat.com> - 2.01.06-1.1
- Extra /dev scanning required for clustered operation.

* Thu Mar 03 2005 Alasdair Kergon <agk@redhat.com> - 2.01.06-1.0
- More clvmd gulm fixes.

* Wed Feb 09 2005 Alasdair Kergon <agk@redhat.com> - 2.01.04-1.0
- Some more clvmd fixes.

* Mon Feb 07 2005 Chris Feist <cfeist@redhat.com> - 2.01.03-2.0
- Added chkconfig --add & --del to start init scripts.

* Tue Feb 01 2005 Alasdair Kergon <agk@redhat.com> - 2.01.03-1.0
- clvmd startup mesgs improved; avoid gulm hang after node reboot

* Fri Jan 21 2005 Alasdair Kergon <agk@redhat.com> - 2.01.02-1.0
- clvmd startup fix; recognise gnbd; improve error reporting.

* Thu Jan 20 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.2
- Install the correct clvmd init script.

* Wed Jan 19 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.1
- Fix spec file for 2.01.

* Wed Jan 19 2005 Alasdair Kergon <agk@redhat.com> - 2.01.01-1.0
- Fix clvmd build & update vgcreate man page.

* Mon Jan 17 2005 Alasdair Kergon <agk@redhat.com> - 2.01.00-1.0
- Include cman & gulm in same library.
- Remove cluster subdir.

* Thu Dec 23 2004 Chris Feist <cfeist@redhat.com> - 2.00.32-1.0
- New upstream sources.

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com> - 2.00.29-1.11
- Added init script for clvm.

* Wed Dec 15 2004 Chris Feist <cfeist@redhat.com> - 2.00.29-1.11
- Use %{_libdir} which fixes 64 bit architecture build problems.

* Wed Dec 1 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.2
- Remove superfluous Requires.

* Tue Nov 30 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.1
- Sort out most of the files.

* Tue Nov 30 2004 Alasdair Kergon <agk@redhat.com> - 2.00.29-1.0
- Initial import.
